/*
3d Sphere functions example
sphere_gl.dll MUST be used as the display driver to
get this to work.
*/

function game()
{
MapEngine("world.rmp",600);
}

function StartScript()
{
var font = GetSystemFont();
var x = 0;
var y = 0;
/*
SetCameraX(1600);
SetCameraY(1400);*/

var image = LoadImage("image.bmp");
font.drawText(0,0, "Press a key...");
FlipScreen();
GetKey();


//This sets the 3d camera position (x,y, z).  Likewise, you can get the camera positions
//Using Get3DCameraX(), and likewise for Y and Z
//The default position is (0,0,0)
	  SwitchProjectMode(1);


Set3DCameraPosition(50, 45, -5);

//This sets the 3d camera angles (with reference to the x axis, y axis and z axis
//respectively.  As before you can get the angles as well
Set3DCameraAngles(/*Get3DCameraAngleX()*/120, Get3DCameraAngleY(), Get3DCameraAngleZ()+180);

var temp = 0;
	while(!IsKeyPressed(KEY_ESCAPE))
	{
	  //This command switches to the perspective drawing mode.
	  //All 3d drawing should be done while in this mode
	  //The order of drawing does not matter, the correct order
	  //will be done.
	  SwitchProjectMode(1);
    
    //This is the prototype map blitting using 3d perspective.
    //I.E: mode7 perspective maps
		PRenderMap();
    //This is a triangle blit.  It consists of 3 sets of 5 values
    //each representing a point of the triangle.  The first two values
    //are the 2d image ordinates (x,y) going from 0 to image.width and image.height,
    //while the next 3 are the 3d (x,y,z) point to put the image.  This is useful
    //for texture mapping complex 3d models.
		image.triangle3DBlit(
		0,0,
		-1.0+50, -1.0+50,  1.0, 
		image.width,0,
		1.0+50, -1.0+50,  1.0, 
		0,image.height,
		1.0+50,  -3.0+50,  1.0);

    //This is similar to the 3d blit, but it uses a square in 3d.  The coordinates
    //represent the corners of the quad.
		image.transform3DBlit(
		-1.0+50, -1.0+50, -1.0, 
		1.0+50, -1.0+50, -1.0, 
		1.0+50,  1.0+50, -1.0, 
		-1.0+50,  1.0+50, -1.0);

		image.transform3DBlit(
		-1.0+50, -1.0+50, -1.0, 
		-1.0+50,  1.0+50, -1.0, 
		 1.0+50,  1.0+50, -1.0, 
		1.0+50, -1.0+50, -1.0);
		
		image.transform3DBlit(
		-1.0+50,  1.0+50, -1.0, 
		-1.0+50,  1.0+50,  1.0, 
		 1.0+50,  1.0+50,  1.0, 
		1.0+50,  1.0+50, -1.0);
		
		image.transform3DBlit(
		-1.0+50, -1.0+50, -1.0, 
		1.0+50, -1.0+50, -1.0, 
		1.0+50, -1.0+50,  1.0, 
		-1.0+50, -1.0+50,  1.0);
		
		image.transform3DBlit(
		1.0+50, -1.0+50, -1.0, 
		1.0+50,  1.0+50, -1.0, 
		1.0+50,  1.0+50,  1.0, 
		1.0+50, -1.0+50,  1.0);
		
		image.transform3DBlit(
		-1.0+50, -1.0+50, -1.0, 
		-1.0+50, -1.0+50,  1.0, 
		-1.0+50,  1.0+50,  1.0, 
		-1.0+50,  1.0+50, -1.0);

            image.sprite(50,55,0,1);
		//This is just input for changing the 3d camera values and the 2d camera
		//values in the map engine (which is used in HRenderMap())
    
    if (IsKeyPressed(KEY_A))
      Set3DCameraPosition(Get3DCameraX()+0.2, Get3DCameraY(), Get3DCameraZ());
    if (IsKeyPressed(KEY_D))
      Set3DCameraPosition(Get3DCameraX()-0.2, Get3DCameraY(), Get3DCameraZ());

    if (IsKeyPressed(KEY_W))
      Set3DCameraPosition(Get3DCameraX(), Get3DCameraY()+0.2, Get3DCameraZ());
    if (IsKeyPressed(KEY_S))
      Set3DCameraPosition(Get3DCameraX(), Get3DCameraY()-0.2, Get3DCameraZ());

    if (IsKeyPressed(KEY_Q))
      Set3DCameraPosition(Get3DCameraX(), Get3DCameraY(), Get3DCameraZ()-0.1);
    if (IsKeyPressed(KEY_Z))
      Set3DCameraPosition(Get3DCameraX(), Get3DCameraY(), Get3DCameraZ()+0.1);


    if (IsKeyPressed(KEY_UP))
      Set3DCameraAngles(Get3DCameraAngleX()-0.5, Get3DCameraAngleY(), Get3DCameraAngleZ());
    if (IsKeyPressed(KEY_DOWN))
       Set3DCameraAngles(Get3DCameraAngleX()+0.5, Get3DCameraAngleY(), Get3DCameraAngleZ());
    if (IsKeyPressed(KEY_LEFT))
      Set3DCameraAngles(Get3DCameraAngleX(), Get3DCameraAngleY(), Get3DCameraAngleZ()+0.5);
    if (IsKeyPressed(KEY_RIGHT))
      Set3DCameraAngles(Get3DCameraAngleX(), Get3DCameraAngleY(), Get3DCameraAngleZ()-0.5);

	  //This command switches back to 2d drawing mode.
    //Using the 2d functions while in the other mode could cause 
    //graphical problems.
	  SwitchProjectMode(0);

    //Since we are now ready for 2d blitting, lets make some basic stuff

		image.transformBlit(0+x,0+y, 120+x,0+y,120+x,120+y,0+x,120+y); 

		font.drawText(0,10, "Manual 3d functions + perspective maps (ESCAPE twice to quit):");
		font.drawText(0,20, "  Keys:");
		font.drawText(0,30, "  Arrow Keys: Turn Camera");
		font.drawText(0,40, "  A/W/S/D: Move Camera sideways and forward");
		font.drawText(0,50, "  Q/Z: Move Camera up and down");
		font.drawText(0,60, "  Home/End/Delete/PageDown: Moves the map around");


    //and FlipScreen acts as normal.  		
		FlipScreen();
    x++;
    y++;
    if (x>640)
      x-=760;
    else if (x>0)
      x = x%760;

    if (y>480)
      y-=600;
    else if (y>0)
    y = y%600;
	}
}